#ifndef TL_LEXER_TOKENS_HPP
#define TL_LEXER_TOKENS_HPP
namespace TL {
namespace TokensC {
   enum yytokentype {
     END = 0,
     ADD_ASSIGN = 258,
     ANDAND = 259,
     AND_ASSIGN = 260,
     ASM = 261,
     TOKEN_AUTO_STORAGE = 262,
     TOKEN_BOOL = 263,
     BOOLEAN_LITERAL = 264,
     BREAK = 265,
     CASE = 266,
     TOKEN_CHAR = 267,
     CHARACTER_LITERAL = 268,
     TOKEN_CONST = 269,
     CONTINUE = 270,
     DECIMAL_LITERAL = 271,
     DEFAULT = 272,
     DIV_ASSIGN = 273,
     DO = 274,
     TOKEN_DOUBLE = 275,
     ELSE = 276,
     ENUM = 277,
     EQUAL = 278,
     EXTERN = 279,
     TOKEN_FLOAT = 280,
     FLOATING_LITERAL = 281,
     HEXADECIMAL_FLOAT = 282,
     FOR = 283,
     GOTO = 284,
     GREATER_OR_EQUAL = 285,
     HEXADECIMAL_LITERAL = 286,
     IDENTIFIER = 287,
     IF = 288,
     INLINE = 289,
     TOKEN_INT = 290,
     TOKEN_INT128 = 291,
     TOKEN_FLOAT128 = 292,
     LEFT = 293,
     LEFT_ASSIGN = 294,
     LESS_OR_EQUAL = 295,
     TOKEN_LONG = 296,
     MINUSMINUS = 297,
     MOD_ASSIGN = 298,
     MUL_ASSIGN = 299,
     NOT_EQUAL = 300,
     OCTAL_LITERAL = 301,
     OR_ASSIGN = 302,
     OROR = 303,
     PLUSPLUS = 304,
     PTR_OP = 305,
     REGISTER = 306,
     RETURN = 307,
     RIGHT = 308,
     RIGHT_ASSIGN = 309,
     TOKEN_SHORT = 310,
     TOKEN_SIGNED = 311,
     SIZEOF = 312,
     STATIC = 313,
     STRING_LITERAL = 314,
     STRUCT = 315,
     SUB_ASSIGN = 316,
     SWITCH = 317,
     ELLIPSIS = 318,
     TYPEDEF = 319,
     UNION = 320,
     TOKEN_UNSIGNED = 321,
     TOKEN_VOID = 322,
     TOKEN_VOLATILE = 323,
     WHILE = 324,
     XOR_ASSIGN = 325,
     PP_COMMENT = 326,
     PP_TOKEN = 327,
     MCC_REFERENCE = 328,
     MCC_REBINDABLE_REFERENCE = 329,
     BUILTIN_VA_ARG = 330,
     BUILTIN_OFFSETOF = 331,
     BUILTIN_CHOOSE_EXPR = 332,
     BUILTIN_TYPES_COMPATIBLE_P = 333,
     TOKEN_GCC_ALIGNOF = 334,
     EXTENSION = 335,
     REAL = 336,
     IMAG = 337,
     LABEL = 338,
     COMPLEX = 339,
     IMAGINARY = 340,
     TYPEOF = 341,
     RESTRICT = 342,
     TOKEN_GCC_ATTRIBUTE = 343,
     THREAD = 344,
     SUBPARSE_EXPRESSION = 345,
     SUBPARSE_EXPRESSION_LIST = 346,
     SUBPARSE_STATEMENT = 347,
     SUBPARSE_DECLARATION = 348,
     SUBPARSE_MEMBER = 349,
     SUBPARSE_TYPE = 350,
     SUBPARSE_TYPE_LIST = 351,
     SUBPARSE_ID_EXPRESSION = 352,
     NODECL_LITERAL_EXPR = 353,
     NODECL_LITERAL_STMT = 354,
     SYMBOL_LITERAL_REF = 355,
     TYPE_LITERAL_REF = 356,
     MCC_BYTE = 357,
     MCC_BOOL = 358,
     MCC_MASK = 359,
     C_FORTRAN_ALLOCATE = 360,
     STATEMENT_PLACEHOLDER = 361,
     UNKNOWN_PRAGMA = 362,
     VERBATIM_PRAGMA = 363,
     VERBATIM_CONSTRUCT = 364,
     VERBATIM_TYPE = 365,
     VERBATIM_TEXT = 366,
     PRAGMA_CUSTOM = 367,
     PRAGMA_CUSTOM_NEWLINE = 368,
     PRAGMA_CUSTOM_DIRECTIVE = 369,
     PRAGMA_CUSTOM_CONSTRUCT = 370,
     PRAGMA_CUSTOM_END_CONSTRUCT = 371,
     PRAGMA_CUSTOM_CONSTRUCT_NOEND = 372,
     PRAGMA_CUSTOM_END_CONSTRUCT_NOEND = 373,
     PRAGMA_CUSTOM_CLAUSE = 374,
     PRAGMA_CLAUSE_ARG_TEXT = 375,
     SUBPARSE_OPENMP_DECLARE_REDUCTION = 376,
     SUBPARSE_OPENMP_DEPEND_ITEM = 377,
     TWO_DOTS = 378,
     SUBPARSE_SUPERSCALAR_DECLARATOR = 379,
     SUBPARSE_SUPERSCALAR_DECLARATOR_LIST = 380,
     SUBPARSE_SUPERSCALAR_EXPRESSION = 381,
     UPC_MYTHREAD = 382,
     UPC_RELAXED = 383,
     UPC_SHARED = 384,
     UPC_STRICT = 385,
     UPC_THREADS = 386,
     UPC_BARRIER = 387,
     UPC_BLOCKSIZEOF = 388,
     UPC_ELEMSIZEOF = 389,
     UPC_FENCE = 390,
     UPC_FORALL = 391,
     UPC_LOCALSIZEOF = 392,
     UPC_MAX_BLOCKSIZE = 393,
     UPC_NOTIFY = 394,
     UPC_WAIT = 395,
     CUDA_DEVICE = 396,
     CUDA_GLOBAL = 397,
     CUDA_HOST = 398,
     CUDA_CONSTANT = 399,
     CUDA_SHARED = 400,
     CUDA_KERNEL_LEFT = 401,
     CUDA_KERNEL_RIGHT = 402,
     OPENCL_GLOBAL = 403,
     OPENCL_KERNEL = 404,
     OPENCL_CONSTANT = 405,
     OPENCL_LOCAL = 406,
     XL_BUILTIN_SPEC = 407,
     TOKEN_DECLSPEC = 408,
     MS_INT8 = 409,
     MS_INT16 = 410,
     MS_INT32 = 411,
     MS_INT64 = 412
   };
}
namespace TokensCXX {
   enum yytokentype {
     END = 0,
     ADD_ASSIGN = 258,
     ANDAND = 259,
     AND_ASSIGN = 260,
     ASM = 261,
     TOKEN_AUTO_STORAGE = 262,
     TOKEN_AUTO_TYPE = 263,
     TOKEN_BOOL = 264,
     BOOLEAN_LITERAL = 265,
     BREAK = 266,
     CASE = 267,
     CATCH = 268,
     TOKEN_CHAR = 269,
     CHARACTER_LITERAL = 270,
     CLASS = 271,
     TOKEN_CONST = 272,
     CONST_CAST = 273,
     CONTINUE = 274,
     DECIMAL_LITERAL = 275,
     DEFAULT = 276,
     TOKEN_DELETE = 277,
     TOKEN_DELETE_ARRAY = 278,
     DIV_ASSIGN = 279,
     DO = 280,
     TWO_COLONS = 281,
     TOKEN_DOUBLE = 282,
     DYNAMIC_CAST = 283,
     ELSE = 284,
     ENUM = 285,
     EQUAL = 286,
     DECLTYPE = 287,
     EXPLICIT = 288,
     EXPORT = 289,
     EXTERN = 290,
     TOKEN_FLOAT = 291,
     FLOATING_LITERAL = 292,
     HEXADECIMAL_FLOAT = 293,
     FOR = 294,
     FRIEND = 295,
     GOTO = 296,
     HEXADECIMAL_LITERAL = 297,
     IDENTIFIER = 298,
     IF = 299,
     INLINE = 300,
     TOKEN_INT = 301,
     TOKEN_INT128 = 302,
     TOKEN_FLOAT128 = 303,
     LEFT = 304,
     LEFT_ASSIGN = 305,
     LESS_OR_EQUAL = 306,
     TOKEN_LONG = 307,
     MINUSMINUS = 308,
     MOD_ASSIGN = 309,
     MUL_ASSIGN = 310,
     MUTABLE = 311,
     NAMESPACE = 312,
     TOKEN_NEW = 313,
     TOKEN_NEW_ARRAY = 314,
     NOT_EQUAL = 315,
     OCTAL_LITERAL = 316,
     OPERATOR = 317,
     OPERATOR_LITERAL = 318,
     OR_ASSIGN = 319,
     OROR = 320,
     PLUSPLUS = 321,
     PRIVATE = 322,
     PROTECTED = 323,
     PTR_OP = 324,
     PTR_OP_MUL = 325,
     PUBLIC = 326,
     REGISTER = 327,
     REINTERPRET_CAST = 328,
     RETURN = 329,
     TOKEN_SHORT = 330,
     TOKEN_SIGNED = 331,
     SIZEOF = 332,
     STATIC = 333,
     STATIC_CAST = 334,
     STRING_LITERAL = 335,
     STRUCT = 336,
     SUB_ASSIGN = 337,
     SWITCH = 338,
     TEMPLATE = 339,
     TOKEN_THIS = 340,
     THROW = 341,
     ELLIPSIS = 342,
     TRY = 343,
     TYPEDEF = 344,
     TYPEID = 345,
     TYPENAME = 346,
     UNION = 347,
     TOKEN_UNSIGNED = 348,
     USING = 349,
     VIRTUAL = 350,
     TOKEN_VOID = 351,
     TOKEN_VOLATILE = 352,
     TOKEN_WCHAR_T = 353,
     TOKEN_CHAR16_T = 354,
     TOKEN_CHAR32_T = 355,
     TOKEN_ALIGNOF = 356,
     WHILE = 357,
     XOR_ASSIGN = 358,
     STATIC_ASSERT = 359,
     PP_COMMENT = 360,
     PP_TOKEN = 361,
     MCC_REBINDABLE_REFERENCE = 362,
     GXX_HAS_NOTHROW_ASSIGN = 363,
     GXX_HAS_NOTHROW_CONSTRUCTOR = 364,
     GXX_HAS_NOTHROW_COPY = 365,
     GXX_HAS_TRIVIAL_ASSIGN = 366,
     GXX_HAS_TRIVIAL_CONSTRUCTOR = 367,
     GXX_HAS_TRIVIAL_COPY = 368,
     GXX_HAS_TRIVIAL_DESTRUCTOR = 369,
     GXX_HAS_VIRTUAL_DESTRUCTOR = 370,
     GXX_IS_ABSTRACT = 371,
     GXX_IS_BASE_OF = 372,
     GXX_IS_CLASS = 373,
     GXX_IS_CONVERTIBLE_TO = 374,
     GXX_IS_EMPTY = 375,
     GXX_IS_ENUM = 376,
     GXX_IS_LITERAL_TYPE = 377,
     GXX_IS_POD = 378,
     GXX_IS_POLYMORPHIC = 379,
     GXX_IS_STANDARD_LAYOUT = 380,
     GXX_IS_TRIVIAL = 381,
     GXX_IS_UNION = 382,
     GXX_IS_FINAL = 383,
     GXX_UNDERLYING_TYPE = 384,
     RIGHT = 385,
     RIGHT_ASSIGN = 386,
     GREATER_OR_EQUAL = 387,
     AB1 = 388,
     AB2 = 389,
     TOKEN_CONSTEXPR = 390,
     TOKEN_THREAD_LOCAL = 391,
     TOKEN_NULLPTR = 392,
     TOKEN_NOEXCEPT = 393,
     TOKEN_NOEXCEPT_ALONE = 394,
     BUILTIN_VA_ARG = 395,
     BUILTIN_OFFSETOF = 396,
     TOKEN_GCC_ALIGNOF = 397,
     EXTENSION = 398,
     REAL = 399,
     IMAG = 400,
     LABEL = 401,
     COMPLEX = 402,
     TYPEOF = 403,
     RESTRICT = 404,
     TOKEN_GCC_ATTRIBUTE = 405,
     THREAD = 406,
     SUBPARSE_EXPRESSION = 407,
     SUBPARSE_EXPRESSION_LIST = 408,
     SUBPARSE_STATEMENT = 409,
     SUBPARSE_DECLARATION = 410,
     SUBPARSE_MEMBER = 411,
     SUBPARSE_TYPE = 412,
     SUBPARSE_TYPE_LIST = 413,
     SUBPARSE_ID_EXPRESSION = 414,
     NODECL_LITERAL_EXPR = 415,
     NODECL_LITERAL_STMT = 416,
     SYMBOL_LITERAL_REF = 417,
     TYPE_LITERAL_REF = 418,
     MCC_BYTE = 419,
     MCC_BOOL = 420,
     MCC_MASK = 421,
     C_FORTRAN_ALLOCATE = 422,
     STATEMENT_PLACEHOLDER = 423,
     UNKNOWN_PRAGMA = 424,
     VERBATIM_PRAGMA = 425,
     VERBATIM_CONSTRUCT = 426,
     VERBATIM_TYPE = 427,
     VERBATIM_TEXT = 428,
     PRAGMA_CUSTOM = 429,
     PRAGMA_CUSTOM_NEWLINE = 430,
     PRAGMA_CUSTOM_DIRECTIVE = 431,
     PRAGMA_CUSTOM_CONSTRUCT = 432,
     PRAGMA_CUSTOM_END_CONSTRUCT = 433,
     PRAGMA_CUSTOM_CONSTRUCT_NOEND = 434,
     PRAGMA_CUSTOM_END_CONSTRUCT_NOEND = 435,
     PRAGMA_CUSTOM_CLAUSE = 436,
     PRAGMA_CLAUSE_ARG_TEXT = 437,
     SUBPARSE_OPENMP_DECLARE_REDUCTION = 438,
     SUBPARSE_OPENMP_DEPEND_ITEM = 439,
     TWO_DOTS = 440,
     SUBPARSE_SUPERSCALAR_DECLARATOR = 441,
     SUBPARSE_SUPERSCALAR_DECLARATOR_LIST = 442,
     SUBPARSE_SUPERSCALAR_EXPRESSION = 443,
     CUDA_DEVICE = 444,
     CUDA_GLOBAL = 445,
     CUDA_HOST = 446,
     CUDA_CONSTANT = 447,
     CUDA_SHARED = 448,
     CUDA_KERNEL_LEFT = 449,
     CUDA_KERNEL_RIGHT = 450,
     OPENCL_GLOBAL = 451,
     OPENCL_KERNEL = 452,
     OPENCL_CONSTANT = 453,
     OPENCL_LOCAL = 454,
     XL_BUILTIN_SPEC = 455,
     TOKEN_DECLSPEC = 456,
     MS_INT8 = 457,
     MS_INT16 = 458,
     MS_INT32 = 459,
     MS_INT64 = 460
   };
}
namespace TokensFortran {
   enum yytokentype {
     END = 0,
     TOKEN_FORMAT = 258,
     TOKEN_GENERIC = 259,
     TOKEN_VOLATILE = 260,
     TOKEN_EQUIVALENCE = 261,
     TOKEN_EOR = 262,
     TOKEN_PROTECTED = 263,
     TOKEN_PAD = 264,
     TOKEN_FILE = 265,
     TOKEN_UNFORMATTED = 266,
     TOKEN_NAMED = 267,
     TOKEN_SUBROUTINE = 268,
     TOKEN_OPENED = 269,
     TOKEN_DELIM = 270,
     TOKEN_SOURCE = 271,
     TOKEN_CRITICAL = 272,
     TOKEN_ACTION = 273,
     TOKEN_IMPORT = 274,
     TOKEN_BLOCK = 275,
     TOKEN_ENUM = 276,
     TOKEN_OVERRIDABLE = 277,
     TOKEN_MODULE = 278,
     TOKEN_SIGN = 279,
     TOKEN_EXTENDS = 280,
     TOKEN_PASS = 281,
     TOKEN_GO = 282,
     TOKEN_ENTRY = 283,
     TOKEN_WHERE = 284,
     TOKEN_ENDWHERE = 285,
     TOKEN_PROCEDURE = 286,
     TOKEN_NAME = 287,
     TOKEN_DOUBLE = 288,
     TOKEN_CONTAINS = 289,
     TOKEN_LOGICAL = 290,
     TOKEN_NEWUNIT = 291,
     TOKEN_NULLIFY = 292,
     TOKEN_DEFERRED = 293,
     TOKEN_ONLY = 294,
     TOKEN_EXIST = 295,
     TOKEN_INTERFACE = 296,
     TOKEN_SAVE = 297,
     TOKEN_ADVANCE = 298,
     TOKEN_STAT = 299,
     TOKEN_RETURN = 300,
     TOKEN_READWRITE = 301,
     TOKEN_ASSIGNMENT = 302,
     TOKEN_ASSIGN = 303,
     TOKEN_PRINT = 304,
     TOKEN_IOSTAT = 305,
     TOKEN_SYNC = 306,
     TOKEN_COMPLEX = 307,
     TOKEN_ASYNCHRONOUS = 308,
     TOKEN_IMAGES = 309,
     TOKEN_END = 310,
     TOKEN_FINAL = 311,
     TOKEN_INOUT = 312,
     TOKEN_NEXTREC = 313,
     TOKEN_KIND = 314,
     TOKEN_COMMON = 315,
     TOKEN_BLANK = 316,
     TOKEN_IOLENGTH = 317,
     TOKEN_INTEGER = 318,
     TOKEN_DEALLOCATE = 319,
     TOKEN_FUNCTION = 320,
     TOKEN_C = 321,
     TOKEN_OPENCL = 322,
     TOKEN_ENUMERATOR = 323,
     TOKEN_RECURSIVE = 324,
     TOKEN_SEQUENCE = 325,
     TOKEN_INQUIRE = 326,
     TOKEN_FLUSH = 327,
     TOKEN_ELSE = 328,
     TOKEN_INTENT = 329,
     TOKEN_EXTERNAL = 330,
     TOKEN_OPERATOR = 331,
     TOKEN_OPTIONAL = 332,
     TOKEN_UNIT = 333,
     TOKEN_SIZE = 334,
     TOKEN_NOPASS = 335,
     TOKEN_TYPE = 336,
     TOKEN_MOLD = 337,
     TOKEN_PRECISION = 338,
     TOKEN_PENDING = 339,
     TOKEN_CONTINUE = 340,
     TOKEN_RESULT = 341,
     TOKEN_REAL = 342,
     TOKEN_THEN = 343,
     TOKEN_STREAM = 344,
     TOKEN_DO = 345,
     TOKEN_DEFAULT = 346,
     TOKEN_CONTIGUOUS = 347,
     TOKEN_STOP = 348,
     TOKEN_PAUSE = 349,
     TOKEN_WHILE = 350,
     TOKEN_PROGRAM = 351,
     TOKEN_REC = 352,
     TOKEN_OPEN = 353,
     TOKEN_CASE = 354,
     TOKEN_RECL = 355,
     TOKEN_DIMENSION = 356,
     TOKEN_ELEMENTAL = 357,
     TOKEN_FORALL = 358,
     TOKEN_POSITION = 359,
     TOKEN_FMT = 360,
     TOKEN_READ = 361,
     TOKEN_OUT = 362,
     TOKEN_LOCK = 363,
     TOKEN_DECIMAL = 364,
     TOKEN_SELECT = 365,
     TOKEN_SELECTCASE = 366,
     TOKEN_DIRECT = 367,
     TOKEN_WRITE = 368,
     TOKEN_CODIMENSION = 369,
     TOKEN_CLOSE = 370,
     TOKEN_ID = 371,
     TOKEN_WAIT = 372,
     TOKEN_ALL = 373,
     TOKEN_ELSEWHERE = 374,
     TOKEN_LEN = 375,
     TOKEN_IMPURE = 376,
     TOKEN_EXIT = 377,
     TOKEN_REWIND = 378,
     TOKEN_BACKSPACE = 379,
     TOKEN_NML = 380,
     TOKEN_INTRINSIC = 381,
     TOKEN_PUBLIC = 382,
     TOKEN_ERRMSG = 383,
     TOKEN_NAMELIST = 384,
     TOKEN_USE = 385,
     TOKEN_SUBMODULE = 386,
     TOKEN_ERR = 387,
     TOKEN_ENCODING = 388,
     TOKEN_ACQUIRED = 389,
     TOKEN_ABSTRACT = 390,
     TOKEN_CHARACTER = 391,
     TOKEN_NUMBER = 392,
     TOKEN_CONCURRENT = 393,
     TOKEN_ENDFILE = 394,
     TOKEN_PARAMETER = 395,
     TOKEN_DATA = 396,
     TOKEN_POS = 397,
     TOKEN_PRIVATE = 398,
     TOKEN_ROUND = 399,
     TOKEN_TO = 400,
     TOKEN_SEQUENTIAL = 401,
     TOKEN_ALLOCATE = 402,
     TOKEN_TARGET = 403,
     TOKEN_CLASS = 404,
     TOKEN_CYCLE = 405,
     TOKEN_STATUS = 406,
     TOKEN_IOMSG = 407,
     TOKEN_FORM = 408,
     TOKEN_IS = 409,
     TOKEN_NONE = 410,
     TOKEN_VALUE = 411,
     TOKEN_UNLOCK = 412,
     TOKEN_FORMATTED = 413,
     TOKEN_IN = 414,
     TOKEN_IMPLICIT = 415,
     TOKEN_IF = 416,
     TOKEN_ASSOCIATE = 417,
     TOKEN_BIND = 418,
     TOKEN_ALLOCATABLE = 419,
     TOKEN_ACCESS = 420,
     TOKEN_CALL = 421,
     TOKEN_PURE = 422,
     TOKEN_MEMORY = 423,
     TOKEN_POINTER = 424,
     TOKEN_VECTOR = 425,
     TOKEN_PIXEL = 426,
     TOKEN_NON_OVERRIDABLE = 427,
     TOKEN_NON_INTRINSIC = 428,
     TOKEN_HOLLERITH_CONSTANT = 429,
     TOKEN_ALLSTOP = 430,
     TOKEN_ENDDO = 431,
     TOKEN_ENDIF = 432,
     TOKEN_ENDFUNCTION = 433,
     TOKEN_BLOCKDATA = 434,
     TOKEN_ENDMODULE = 435,
     TOKEN_DOUBLEPRECISION = 436,
     TOKEN_ENDINTERFACE = 437,
     TOKEN_ELSEIF = 438,
     TOKEN_ENDPROCEDURE = 439,
     TOKEN_ENDPROGRAM = 440,
     TOKEN_ENDASSOCIATE = 441,
     TOKEN_ENDSELECT = 442,
     TOKEN_ENDBLOCK = 443,
     TOKEN_ENDSUBMODULE = 444,
     TOKEN_ENDBLOCKDATA = 445,
     TOKEN_ENDSUBROUTINE = 446,
     TOKEN_ENDCRITICAL = 447,
     TOKEN_ENDTYPE = 448,
     TOKEN_DOUBLECOMPLEX = 449,
     TOKEN_GOTO = 450,
     TOKEN_LOGICAL_NOT_EQUIVALENT = 451,
     TOKEN_POINTER_ACCESS = 452,
     TOKEN_GREATER_THAN = 453,
     TOKEN_EQUAL = 454,
     TOKEN_LOGICAL_AND = 455,
     TOKEN_LOWER_THAN = 456,
     TOKEN_LOGICAL_NOT = 457,
     TOKEN_LOGICAL_EQUIVALENT = 458,
     TOKEN_GREATER_OR_EQUAL_THAN = 459,
     TOKEN_LOGICAL_OR = 460,
     TOKEN_LOWER_OR_EQUAL_THAN = 462,
     TOKEN_NOT_EQUAL = 463,
     TOKEN_RAISE = 464,
     TOKEN_DOUBLE_SLASH = 465,
     TOKEN_LPARENT_SLASH = 466,
     TOKEN_SLASH_RPARENT = 467,
     TOKEN_TRUE = 468,
     TOKEN_FALSE = 469,
     DECIMAL_LITERAL = 470,
     FORMAT_SPEC = 471,
     IDENTIFIER = 472,
     EOS = 473,
     BINARY_LITERAL = 474,
     OCTAL_LITERAL = 475,
     REAL_LITERAL = 476,
     CHAR_LITERAL = 477,
     HEX_LITERAL = 478,
     USER_DEFINED_OPERATOR = 479,
     TOKEN_END_NONBLOCK_DO = 480,
     TOKEN_SHARED_LABEL = 481,
     GLOBAL = 482,
     END_GLOBAL = 483,
     TYPEDEF = 484,
     TOKEN_IS_VARIABLE = 485,
     SUBPARSE_PROGRAM_UNIT = 486,
     SUBPARSE_EXPRESSION = 487,
     SUBPARSE_STATEMENT = 488,
     NODECL_LITERAL_EXPR = 489,
     NODECL_LITERAL_STMT = 490,
     SYMBOL_LITERAL_REF = 491,
     TYPE_LITERAL_REF = 492,
     UNKNOWN_PRAGMA = 493,
     PRAGMA_CUSTOM = 494,
     PRAGMA_CUSTOM_NEWLINE = 495,
     PRAGMA_CUSTOM_DIRECTIVE = 496,
     PRAGMA_CUSTOM_CONSTRUCT = 497,
     PRAGMA_CUSTOM_END_CONSTRUCT = 498,
     PRAGMA_CUSTOM_CONSTRUCT_NOEND = 499,
     PRAGMA_CUSTOM_END_CONSTRUCT_NOEND = 500,
     PRAGMA_CUSTOM_CLAUSE = 501,
     PRAGMA_CLAUSE_ARG_TEXT = 502,
     STATEMENT_PLACEHOLDER = 503,
     SUBPARSE_OPENMP_DECLARE_REDUCTION = 504,
     SUBPARSE_OPENMP_DEPEND_ITEM = 505
   };
}
}
#endif // TL_LEXER_TOKENS_HPP
